<TeXmacs|1.99.5>

<style|<tuple|beamer|mathemagix|vdh|pari|caas|math-ss>>

<\body>
  <screens|<\shown>
    \;

    <\with|par-mode|center>
      <strong|<\with|font-base-size|15>
        <strong|<strong|Multiple precision floating point
        arithmetic<new-line> on SIMD processors>>
      </with>>

      <strong|Joris van der Hoeven>

      <small|CNRS, cole polytechnique>
    </with>

    <\with|par-mode|center>
      <tabular*|<tformat|<table|<row|<cell|>|<cell|<img|<image|texmacs-chip.ps|0.6w|0.6h||>>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<strong|London,
      July 24, 2017<rsub|<math|<rsub|>>>>>|<cell|>>|<row|<cell|>|<cell|<verbatim|http://www.<anim-repeat|<anim-compose|<anim-constant|<with|color|brown|T<space|-0.2spc><with|color|brown|<rsub|<with|math-level|0|font-shape|small-caps|e>>>X<space|-0.2spc>><with|color|dark
      green|<rsub|<with|math-level|0|font-shape|small-caps|m<space|-0.2spc>a<space|-0.4spc>c<space|-0.2spc>s>>>|1sec>|<anim-constant|<with|color|dark
      green|T<space|-0.2spc><with|color|brown|<rsub|<with|math-level|0|font-shape|small-caps|e>>>X<space|-0.2spc>><with|color|brown|<rsub|<with|math-level|0|font-shape|small-caps|m<space|-0.2spc>a<space|-0.4spc>c<space|-0.2spc>s>>>|1sec>>>.org>>|<cell|>>>>>
    </with>

    \;
  </shown>|<\hidden>
    <tit|The challenge: fast multiple precision arithmetic for scientific
    computation>

    <unroll|<\shown>
      <strong|Theoretical efficiency of multiple precision floating point
      arithmetic>

      <\itemize>
        <item>Mainly boils down to the complexity
        <math|<math-ss|M><around*|(|k|)>> of <math|k>-\Pword\Q
        multiplication.

        <item>For small <math|k>, we have
        <math|<math-ss|M><around*|(|k|)>\<approx\>\<alpha\>*k<rsup|2>> for
        some constant <math|\<alpha\>>.

        <item>For large <math|k>, we have
        <math|<math-ss|M><around*|(|k|)>=O<around*|(|k*log
        k*8<rsup|log<rsup|\<ast\>> k>|)>>: Harvey\UvdH\ULecerf, <abbr|J.> of
        Complexity 2016.

        <item>For <math|10\<lessapprox\>k\<lessapprox\>1000>, intermediate
        regimes apply: Karatsuba, Toom\UCook, etc.
      </itemize>
    </shown>|<\hidden*>
      <vspace*|1fn><strong|How does this translate in
      practice<space|0.2spc>?>
    </hidden*>|<\hidden*>
      <\itemize>
        <unroll|<\shown>
          <item>How to minimize <math|\<alpha\>> for small
          <math|k\<lessapprox\>10><space|0.2spc>?
        </shown>|<\hidden*>
          <item>How does <math|\<alpha\>> depend on the
          architecture<space|0.2spc>?
        </hidden*>|<\hidden*>
          <item>What about SIMD-style vectorization<space|0.2spc>?
        </hidden*>|<\hidden*>
          <item>To what extent do additions and subtractions
          matter<space|0.2spc>?
        </hidden*>>
      </itemize>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Modern architectures>

    <unroll|<\shown>
      <strong|The issues>

      <\itemize>
        <unroll|<\shown>
          <item>What are the available word sizes <math|\<mu\>> in
          bits<space|0.2spc>?
        </shown>|<\hidden*>
          <item>What is the available SIMD width <math|w> for the best word
          size <math|\<mu\>><space|0.2spc>?
        </hidden*>|<\hidden*>
          <\equation*>
            Efficiency<space|0.6spc>\<propto\><space|0.6spc>\<mu\><rsup|2>*w
          </equation*>
        </hidden*>|<\hidden*>
          <item>Is (efficient) hardware integer arithmetic available? If so,

          <\equation*>
            Efficiency<rsub|\<bbb-Z\>><space|0.6spc>\<approx\><space|0.6spc><around*|(|<tfrac|64|53>|)><rsup|2>*Efficiency<rsub|\<bbb-F\>><space|0.6spc>\<approx\><space|0.6spc>1.5*Efficiency<rsub|\<bbb-F\>>.
          </equation*>
        </hidden*>>
      </itemize>
    </shown>|<\hidden*>
      <strong|Currently>

      <\itemize>
        <item><math|\<mu\>=53> and <math|w=4> on AVX2-enabled processors. No
        efficient 64-bit integer arithmetic.

        <item><math|\<mu\>=24> and <math|16\<leqslant\>w\<leqslant\>64> on
        cheap GPUs. No efficient 32-bit integer arithmetic.

        <item><math|\<mu\>=53> and <math|16\<leqslant\>w\<leqslant\>64> on
        expensive GPUs. No efficient 64-bit integer arithmetic.

        <item>FGPAs: not considered here.
      </itemize>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Approaches for multiple precision floating point arithmetic>

    <unroll|<\shown>
      Notation: <math|\<bbb-F\>> is the set of hardware floating point
      numbers<vspace|1fn>
    </shown>|<\hidden*>
      <strong|Floating point expansions>

      <\itemize>
        <unroll|<\shown>
          <item>Based on an exact representation
          <math|x=x<rsub|1>+\<cdots\>+x<rsub|k>> with
          <math|x<rsub|1>,\<ldots\>,x<rsub|k>\<in\>\<bbb-F\>>
        </shown>|<\hidden*>
          <item>Exploit error-free transformations when doing operations
        </hidden*>|<\hidden*>
          <item>Efficient for <math|k=2>, <math|k=3>, and <math|k=4>
          (<abbr|cf.> <name|QD> library by Bailey et al.)
        </hidden*>|<\hidden*>
          <item>Muller\UPopescu\UTang, ARITH 2016, \Pop-count\Q
          <math|<math-ss|M><around*|(|k|)>\<leqslant\><frac|13|2>*k<rsup|2>+<frac|45|2>*k+67><vspace|1fn>
        </hidden*>>
      </itemize>
    </hidden*>|<\hidden*>
      <strong|Separate treatment of mantissas and exponents>

      <\itemize>
        <unroll|<\shown>
          <item>Standard representation <math|x=m*2<rsup|e>> with
          <math|m=m<rsub|0>+m<rsub|1>*2<rsup|-p>+\<cdots\>+m<rsub|k-1>*2<rsup|-<around*|(|k-1|)>*p>>
        </shown>|<\hidden*>
          <item>Fixed-point arithmetic operations on the mantissas <math|m>
        </hidden*>|<\hidden*>
          <item>Very efficient for large <math|k> (<abbr|cf.> GMP and
          <name|MPFR> libraries)
        </hidden*>|<\hidden*>
          <item>However: GMP and MPFR are currently not vectorized and very
          inefficient for small <math|k>
        </hidden*>|<\hidden*>
          <item><with|color|dark magenta|Efficiency for small and medium
          <math|k><space|0.2spc>?>
        </hidden*>|<\hidden*>
          <item><with|color|dark magenta|SIMD-style
          vectorization<space|0.2spc>?>
        </hidden*>>
      </itemize>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Fixed-point arithmetic >

    Idea (vdH\ULecerf, ARITH 2015): use redundant representation with \Pnail
    bits\Q:

    <\eqnarray*>
      <tformat|<cwith|3|3|3|3|cell-bsep|2spc>|<table|<row|<cell|x>|<cell|=>|<cell|m*2<rsup|e>>>|<row|<cell|m>|<cell|=>|<cell|m<rsub|0>+m<rsub|1>*2<rsup|-p>+\<cdots\>+m<rsub|k-1>*2<rsup|-<around*|(|k-1|)>*p>>>|<row|<cell|p>|<cell|=>|<cell|\<mu\>-\<delta\>>>|<row|<cell|\<delta\>>|<cell|\<approx\>>|<cell|4,<text|
      suitable number of \Pnail bits\Q>>>|<row|<cell|m<rsub|i>>|<cell|\<in\>>|<cell|\<bbb-Z\>*2<rsup|-p>>>>>
    </eqnarray*>

    Thus: <math|<around*|\||m|\|>\<less\>2<rsup|\<delta\>>> and
    <math|m\<in\>\<bbb-Z\>*2<rsup|-k*p>>.

    <htab|5mm><with|gr-mode|<tuple|edit|math-at>|gr-frame|<tuple|scale|1cm|<tuple|0.27gw|0.619996gh>>|gr-geometry|<tuple|geometry|0.727451par|0.286908par|center>|gr-transformation|<tuple|<tuple|0.764842187284488|0.0|-0.64421768723769|0.0>|<tuple|0.0|1.0|0.0|0.0>|<tuple|0.64421768723769|0.0|0.764842187284488|0.0>|<tuple|0.0|0.0|0.0|1.0>>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|4|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-text-at-halign|center|gr-text-at-valign|center|gr-auto-crop|true|<graphics||<line|<point|-1.0|1.0>|<point|-1.0|0.0>|<point|3.0|0.0>|<point|3.0|1.0>|<point|-1.0|1.0>>|<with|text-at-valign|center|text-at-halign|center|<math-at|m<rsub|0>|<point|-2|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|m<rsub|1>*2<rsup|-p>|<point|-2|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<delta\>|<point|-0.5|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|1.5|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<delta\>|<point|2.5|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|4.5|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-2*p>|<point|6.0|1.75>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-p>|<point|3.0|1.75>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|1|<point|0.0|1.75>>>|<line|<point|2|-0.5>|<point|2.0|-1.5>|<point|6.0|-1.5>|<point|6.0|-1.0>|<point|6.0|-0.5>|<point|2.0|-0.5>>|<with|dash-style|11100|<line|<point|0.0|1.49690765974335>|<point|0.0|-3.5>>>|<with|dash-style|11100|<line|<point|3.0|1.46742293954227>|<point|3.0|-3.5>>>|<with|dash-style|11100|<line|<point|6.0|1.46173435639635>|<point|6.0|-3.5>>>|<with|dash-style|11100|<spline|<point|9|1.5>|<point|9.0|-3.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<delta\>|<point|5.5|-2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|7.5|-2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|m<rsub|2>*2<rsup|-2*p>|<point|-2|-2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-3*p>|<point|9|1.75>>>|<line|<point|5|-2>|<point|5.0|-3.0>|<point|9.0|-3.0>|<point|9.0|-2.0>|<point|5.0|-2.0>>>><htab|5mm>

    \;
  </hidden>|<\hidden>
    <tit|Efficient non-normalized arithmetic ...>

    <with|gr-mode|<tuple|edit|line>|gr-frame|<tuple|scale|1cm|<tuple|0.5gw|0.569998gh>>|gr-geometry|<tuple|geometry|1par|0.613008par|center>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|4|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-text-at-halign|center|gr-text-at-valign|center|gr-color|blue|gr-arrow-end|\<gtr\>|<graphics||<cline|<point|-4|6>|<point|-4.0|5.0>|<point|0.0|5.0>|<point|0.0|6.0>>|<cline|<point|-2|4.5>|<point|-2.0|3.5>|<point|2.0|3.5>|<point|2.0|4.5>>|<with|color|blue|dash-style|10|<line|<point|0|2>|<point|0.0|-8.0>>>|<cline|<point|-2|3>|<point|-2.0|2.0>|<point|2.0|2.0>|<point|2.0|3.0>>|<with|dash-style|10|<line|<point|-2|6>|<point|-2.0|5.0>>>|<with|dash-style|10|<line|<point|0|4.5>|<point|0.0|3.5>>>|<with|dash-style|10|<line|<point|0|3>|<point|0.0|2.0>>>|<with|dash-style|10|<line|<point|2|1.5>|<point|2.25|1.25>|<point|2.0|1.0>|<point|2.25|0.75>|<point|2.0|0.5>>>|<with|dash-style|10|<line|<point|2|0>|<point|2.25|-0.25>|<point|2.0|-0.5>|<point|2.25|-0.75>|<point|2.0|-1.0>>>|<with|dash-style|10|<line|<point|2|-1.5>|<point|2.25|-1.75>|<point|2.0|-2.0>|<point|2.25|-2.25>|<point|2.0|-2.5>>>|<line|<point|2|1.5>|<point|0.0|1.5>|<point|0.0|0.5>|<point|2.0|0.5>>|<line|<point|2|0>|<point|0.0|0.0>|<point|0.0|-1.0>|<point|2.0|-1.0>>|<cline|<point|-4|-4>|<point|-4.0|-5.0>|<point|-2.0|-5.0>|<point|-2.0|-4.0>>|<cline|<point|-2.25|-5.5>|<point|-2.25|-6.5>|<point|0.0|-6.5>|<point|0.0|-5.5>>|<with|color|blue|dash-style|10|<line|<point|-2|5>|<point|-2.0|-6.5>>>|<cline|<point|-0.5|-7>|<point|-0.5|-8.0>|<point|2.0|-8.0>|<point|2.25|-7.75>|<point|2.0|-7.5>|<point|2.25|-7.25>|<point|2.0|-7.0>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|0>*y<rsub|0>|<point|-2|5.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|0>*y<rsub|1>|<point|0|4>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|1>*y<rsub|0>|<point|0|2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|0>*y<rsub|2>|<point|1|1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|1>*y<rsub|1>|<point|1|-0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|2>*y<rsub|0>|<point|1|-2>>>|<with|color|blue|dash-style|10|<line|<point|-4|5>|<point|-4.0|-4.0>>>|<with|color|blue|dash-style|10|<line|<point|0|3.5>|<point|0.0|2.89137121312343>>>|<with|color|blue|dash-style|10|<line|<point|0|5>|<point|0.0|4.5>>>|<with|color|blue|dash-style|10|<line|<point|2|3.5>|<point|2.0|3.0>>>|<with|color|blue|dash-style|10|<line|<point|2|2>|<point|2.0|1.5>>>|<with|color|blue|dash-style|10|<line|<point|2|0.5>|<point|2.0|0.0>>>|<with|color|blue|dash-style|10|<line|<point|2|-1>|<point|2.0|-1.5>>>|<with|color|blue|dash-style|10|<line|<point|2|-2.5>|<point|2.0|-7.0>>>|<line|<point|2|-1.5>|<point|0.0|-1.5>|<point|0.0|-2.5>|<point|2.0|-2.5>>|<with|color|blue|text-at-valign|center|text-at-halign|center|<math-at|<with|color|blue|+>|<point|-3|-3.5>>>|<with|color|blue|text-at-valign|center|text-at-halign|center|<math-at|<with|color|blue|+>|<point|-1|-5>>>|<with|color|blue|text-at-valign|center|text-at-halign|center|<math-at|<with|color|blue|+>|<point|1|-6.5>>>|<with|color|blue|arrow-end|\<gtr\>|<line|<point|-3|-1>|<point|-3.0|-2.0>>>|<with|color|blue|arrow-end|\<gtr\>|<line|<point|-1|-2.5>|<point|-1.0|-3.5>>>|<with|color|blue|arrow-end|\<gtr\>|<line|<point|1|-4>|<point|1.0|-5.0>>>>>
  </hidden>|<\hidden>
    <tit|... followed by efficient carry-normalization>

    \;

    <unroll|<\shown>
      <htab|5mm><tiny-switch|<shown|<with|gr-mode|<tuple|edit|math-at>|gr-frame|<tuple|scale|1cm|<tuple|0.27gw|0.619996gh>>|gr-geometry|<tuple|geometry|0.727451par|0.286908par|center>|gr-transformation|<tuple|<tuple|0.764842187284488|0.0|-0.64421768723769|0.0>|<tuple|0.0|1.0|0.0|0.0>|<tuple|0.64421768723769|0.0|0.764842187284488|0.0>|<tuple|0.0|0.0|0.0|1.0>>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|4|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-text-at-halign|center|gr-text-at-valign|center|gr-auto-crop|false|<graphics||<line|<point|-1.0|1.0>|<point|-1.0|0.0>|<point|3.0|0.0>|<point|3.0|1.0>|<point|-1.0|1.0>>|<with|text-at-valign|center|text-at-halign|center|<math-at|m<rsub|0>|<point|-2|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|m<rsub|1>*2<rsup|-p>|<point|-2|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<delta\>|<point|-0.5|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|1.5|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<delta\>|<point|2.5|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|4.5|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-2*p>|<point|6.0|1.75>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-p>|<point|3.0|1.75>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|1|<point|0.0|1.75>>>|<line|<point|2|-0.5>|<point|2.0|-1.5>|<point|6.0|-1.5>|<point|6.0|-1.0>|<point|6.0|-0.5>|<point|2.0|-0.5>>|<with|dash-style|11100|<line|<point|0.0|1.49690765974335>|<point|0.0|-3.5>>>|<with|dash-style|11100|<line|<point|3.0|1.46742293954227>|<point|3.0|-3.5>>>|<with|dash-style|11100|<line|<point|6.0|1.46173435639635>|<point|6.0|-3.5>>>|<with|dash-style|11100|<spline|<point|9|1.5>|<point|9.0|-3.5>>>|<line|<point|5|-2>|<point|5.0|-3.0>|<point|9.0|-3.0>|<point|9.25|-2.75>|<point|9.0|-2.5>|<point|9.25|-2.25>|<point|9.0|-2.0>|<point|5.0|-2.0>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<delta\>|<point|5.5|-2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|7.5|-2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|m<rsub|2>*2<rsup|-2*p>|<point|-2|-2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-3*p>|<point|9|1.75>>>>>>|<hidden|<with|gr-mode|<tuple|edit|line>|gr-frame|<tuple|scale|1.00002cm|<tuple|0.27gw|0.619996gh>>|gr-geometry|<tuple|geometry|0.727451par|0.286908par|center>|gr-transformation|<tuple|<tuple|0.764842187284488|0.0|-0.64421768723769|0.0>|<tuple|0.0|1.0|0.0|0.0>|<tuple|0.64421768723769|0.0|0.764842187284488|0.0>|<tuple|0.0|0.0|0.0|1.0>>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|4|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-text-at-halign|center|gr-text-at-valign|center|gr-auto-crop|false|gr-arrow-end|\<gtr\>|<graphics||<line|<point|-1.0|1.0>|<point|-1.0|0.0>|<point|3.0|0.0>|<point|3.0|1.0>|<point|-1.0|1.0>>|<with|text-at-valign|center|text-at-halign|center|<math-at|m<rsub|0>|<point|-2|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|m<rsub|1>*2<rsup|-p>|<point|-2|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<delta\>|<point|-0.5|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|1.5|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|4.5|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-2*p>|<point|6.0|1.75>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-p>|<point|3.0|1.75>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|1|<point|0.0|1.75>>>|<with|dash-style|11100|<line|<point|0.0|1.49690765974335>|<point|0.0|-3.5>>>|<with|dash-style|11100|<line|<point|3.0|1.46742293954227>|<point|3.0|-3.5>>>|<with|dash-style|11100|<line|<point|6.0|1.46173435639635>|<point|6.0|-3.5>>>|<with|dash-style|11100|<spline|<point|9|1.5>|<point|9.0|-3.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|7.5|-2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|m<rsub|2>*2<rsup|-2*p>|<point|-2|-2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-3*p>|<point|9|1.75>>>|<line|<point|3.125|-0.5>|<point|3.125|-1.5>|<point|6.0|-1.5>|<point|6.0|-1.0>|<point|6.0|-0.5>|<point|3.25|-0.5>>|<line|<point|2.875|-1.5>|<point|2.875|-0.5>|<point|2.0|-0.5>|<point|2.0|-1.5>|<point|2.875|-1.5>>|<line|<point|6.125|-2.0>|<point|6.125|-3.0>|<point|9.0|-3.0>|<point|9.0|-2.0>|<point|6.125|-2.0>>|<line|<point|5.875|-2>|<point|5.875|-3.0>|<point|5.0|-3.0>|<point|5.0|-2.0>|<point|5.875|-2.0>>|<with|arrow-end|\<gtr\>|<line|<point|2.5|-0.5>|<point|2.5|0.0>>>|<with|arrow-end|\<gtr\>|<line|<point|5.5|-2>|<point|5.5|-1.5>>>|<with|color|blue|text-at-valign|center|text-at-halign|center|<math-at|<with|color|blue|+>|<point|5.5|-2.5>>>|<with|color|blue|text-at-valign|center|text-at-halign|center|<math-at|<with|color|blue|+>|<point|2.5|-1.0>>>>>>|<hidden|<with|gr-mode|<tuple|edit|math-at>|gr-frame|<tuple|scale|1cm|<tuple|0.27gw|0.619996gh>>|gr-geometry|<tuple|geometry|0.727451par|0.286908par|center>|gr-transformation|<tuple|<tuple|0.764842187284488|0.0|-0.64421768723769|0.0>|<tuple|0.0|1.0|0.0|0.0>|<tuple|0.64421768723769|0.0|0.764842187284488|0.0>|<tuple|0.0|0.0|0.0|1.0>>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|4|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-text-at-halign|center|gr-text-at-valign|center|gr-auto-crop|false|<graphics||<line|<point|-1.0|1.0>|<point|-1.0|0.0>|<point|3.0|0.0>|<point|3.0|1.0>|<point|-1.0|1.0>>|<with|text-at-valign|center|text-at-halign|center|<math-at|m<rsub|0>|<point|-2|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|m<rsub|1>*2<rsup|-p>|<point|-2|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<delta\>|<point|-0.5|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|1.5|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|4.5|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-2*p>|<point|6.0|1.75>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-p>|<point|3.0|1.75>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|1|<point|0.0|1.75>>>|<with|dash-style|11100|<line|<point|0.0|1.49690765974335>|<point|0.0|-3.5>>>|<with|dash-style|11100|<line|<point|3.0|1.46742293954227>|<point|3.0|-3.5>>>|<with|dash-style|11100|<line|<point|6.0|1.46173435639635>|<point|6.0|-3.5>>>|<with|dash-style|11100|<spline|<point|9|1.5>|<point|9.0|-3.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|7.5|-2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|m<rsub|2>*2<rsup|-2*p>|<point|-2|-2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-3*p>|<point|9|1.75>>>|<line|<point|3.0|-0.5>|<point|3.0|-1.5>|<point|6.0|-1.5>|<point|6.0|-1.0>|<point|6.0|-0.5>|<point|3.0|-0.5>>|<line|<point|6.0|-2.0>|<point|6.0|-3.0>|<point|9.0|-3.0>|<point|9.0|-2.0>|<point|6.0|-2.0>>>>>><htab|5mm>
    </shown>|<\hidden*>
      \;

      <strong|Operation counts>

      <\itemize>
        <unroll|<\shown>
          <item>Multiplication: <math|5*<binom|k|2>+1=<frac|5|2>*k<rsup|2>-<frac|5|2>*k+1>
        </shown>|<\hidden*>
          <item>Carry-normalization: <math|4*k-4>
        </hidden*>|<\hidden*>
          <item>Total: <math|<frac|5|2>*k<rsup|2>+<frac|3|2>*k-3>
        </hidden*>|<\hidden*>
          <item>Remember: <math|<frac|13|2>*k<rsup|2>+<frac|45|2>*k+67>
        </hidden*>>
      </itemize>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Back to floating point arithmetic>

    \;

    <unroll|<\shown>
      <strong|Main problem>: putting arguments under a common
      exponent<htab|5mm>(<abbr|e.g.> <math|0.7\<times\>2<rsup|-7>+0.8\<times\>2<rsup|-12>>)
    </shown>|<\hidden*>
      <space|1em><math|\<rightsquigarrow\>> how to shift mantissas
      efficiently<space|0.2spc>?<htab|5mm>(<abbr|e.g.>
      <math|0.8\<times\>2<rsup|-12>=0.025\<times\>2<rsup|-7>>)
    </hidden*>|<\hidden*>
      <space|1em><math|\<rightsquigarrow\>> how to perform \Pdot
      normalization\Q<space|0.2spc>?<vspace|1fn>
    </hidden*>|<\hidden*>
      <strong|Decomposition of a shift by <math|s> bits>
    </hidden*>|<\hidden*>
      <\itemize>
        <unroll|<\shown>
          <item>as a long shift by <math|\<sigma\>=<around*|\<lfloor\>|s/p|\<rfloor\>>>
          words
        </shown>|<\hidden*>
          <item>and a short shift by <math|s<rprime|'>=s-\<sigma\>*p\<less\>p>
          bits
        </hidden*>|<\hidden*>
          <item>This should be done using SIMD vector
          instructions<vspace|1fn>
        </hidden*>>
      </itemize>
    </hidden*>|<\hidden*>
      <strong|Main design decisions to be made>

      <\itemize>
        <unroll|<\shown>
          <item>Work with arbitrary exponents (<em| la> MPFR) or multiples
          of <math|p> (<em| la> GMP)<space|0.2spc>?
        </shown>|<\hidden*>
          <item>Numbers in an SIMD vector share the same exponent or
          not<space|0.2spc>?
        </hidden*>>
      </itemize>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|long SIMD shifts>

    Idea: any shift by <math|\<sigma\>=\<sigma\><rsub|0>+\<sigma\><rsub|1>*2+\<cdots\>+\<sigma\><rsub|\<ell\>-1>*2<rsup|\<ell\>-1>>
    words with <math|\<sigma\><rsub|i>\<in\><around*|{|0,1|}>><new-line><phantom|Idea:
    >decomposes as <math|\<ell\>> special shifts by
    <math|\<sigma\><rsub|i>*2<rsup|i>\<in\><around*|{|0,2<rsup|i>|}>> words
    (done using <verbatim|blend> instruction)<phantom|<math|\<mathe\><rsup|\<mathe\><rsup|\<mathe\><rsup|\<mathe\><rsup|x>>>>>>

    \;

    <switch|<\shown>
      <htab|5mm><block*|<tformat|<cwith|2|2|1|-1|cell-width|3em>|<cwith|2|2|1|-1|cell-hmode|exact>|<cwith|1|-1|11|13|cell-width|1.5em>|<cwith|1|-1|11|13|cell-hmode|exact>|<cwith|1|1|1|-1|cell-tborder|0ln>|<cwith|1|1|1|-1|cell-bborder|1ln>|<cwith|2|2|1|-1|cell-tborder|1ln>|<cwith|1|1|1|13|cell-lborder|0ln>|<cwith|1|1|1|13|cell-rborder|0ln>|<cwith|2|2|9|9|cell-tborder|0ln>|<cwith|1|1|9|9|cell-bborder|0ln>|<cwith|16|16|9|9|cell-bborder|0ln>|||<cwith|2|-1|9|9|cell-tborder|0ln>|<cwith|2|-1|9|9|cell-bborder|0ln>|<cwith|1|-1|9|9|cell-width|1.5em>|<cwith|1|-1|9|9|cell-hmode|exact>|<cwith|4|4|1|8|cell-width|3em>|<cwith|4|4|1|8|cell-hmode|exact>|<cwith|6|6|1|8|cell-width|3em>|<cwith|6|6|1|8|cell-hmode|exact>|<cwith|6|6|1|8|cell-tborder|1ln>|<cwith|8|8|1|8|cell-width|3em>|<cwith|8|8|1|8|cell-hmode|exact>|<cwith|8|8|1|8|cell-tborder|1ln>|<cwith|10|10|1|8|cell-width|3em>|<cwith|10|10|1|8|cell-hmode|exact>|<cwith|10|10|1|8|cell-tborder|1ln>|<cwith|12|12|1|8|cell-width|3em>|<cwith|12|12|1|8|cell-hmode|exact>|<cwith|12|12|1|8|cell-tborder|1ln>|<cwith|14|14|1|8|cell-width|3em>|<cwith|14|14|1|8|cell-hmode|exact>|<cwith|14|14|1|8|cell-tborder|1ln>|<cwith|16|16|1|8|cell-width|3em>|<cwith|16|16|1|8|cell-hmode|exact>||||||<cwith|3|3|1|-1|cell-lborder|0ln>|<cwith|3|3|1|-1|cell-rborder|0ln>|<cwith|3|3|1|-1|cell-height|4ln>|<cwith|3|3|1|-1|cell-vmode|exact>|<cwith|5|5|11|13|cell-width|1.5em>|<cwith|5|5|11|13|cell-hmode|exact>|<cwith|5|5|9|9|cell-tborder|0ln>|<cwith|5|5|9|9|cell-bborder|0ln>|<cwith|5|5|9|9|cell-width|1.5em>|<cwith|5|5|9|9|cell-hmode|exact>|<cwith|5|5|1|13|cell-lborder|0ln>|<cwith|5|5|1|13|cell-rborder|0ln>|<cwith|5|5|1|13|cell-height|4ln>|<cwith|5|5|1|13|cell-vmode|exact>|<cwith|7|7|11|13|cell-width|1.5em>|<cwith|7|7|11|13|cell-hmode|exact>|<cwith|7|7|9|9|cell-tborder|0ln>|<cwith|7|7|9|9|cell-bborder|0ln>|<cwith|7|7|9|9|cell-width|1.5em>|<cwith|7|7|9|9|cell-hmode|exact>|<cwith|7|7|1|13|cell-lborder|0ln>|<cwith|7|7|1|13|cell-rborder|0ln>|<cwith|7|7|1|13|cell-height|4ln>|<cwith|7|7|1|13|cell-vmode|exact>|<cwith|9|9|11|13|cell-width|1.5em>|<cwith|9|9|11|13|cell-hmode|exact>|<cwith|9|9|9|9|cell-tborder|0ln>|<cwith|9|9|9|9|cell-bborder|0ln>|<cwith|9|9|9|9|cell-width|1.5em>|<cwith|9|9|9|9|cell-hmode|exact>|<cwith|9|9|1|13|cell-lborder|0ln>|<cwith|9|9|1|13|cell-rborder|0ln>|<cwith|9|9|1|13|cell-height|4ln>|<cwith|9|9|1|13|cell-vmode|exact>|<cwith|11|11|11|13|cell-width|1.5em>|<cwith|11|11|11|13|cell-hmode|exact>|<cwith|11|11|9|9|cell-tborder|0ln>|<cwith|11|11|9|9|cell-bborder|0ln>|<cwith|11|11|9|9|cell-width|1.5em>|<cwith|11|11|9|9|cell-hmode|exact>|<cwith|11|11|1|13|cell-lborder|0ln>|<cwith|11|11|1|13|cell-rborder|0ln>|<cwith|11|11|1|13|cell-height|4ln>|<cwith|11|11|1|13|cell-vmode|exact>|<cwith|13|13|11|13|cell-width|1.5em>|<cwith|13|13|11|13|cell-hmode|exact>|<cwith|13|13|9|9|cell-tborder|0ln>|<cwith|13|13|9|9|cell-bborder|0ln>|<cwith|13|13|9|9|cell-width|1.5em>|<cwith|13|13|9|9|cell-hmode|exact>|<cwith|13|13|1|13|cell-lborder|0ln>|<cwith|13|13|1|13|cell-rborder|0ln>|<cwith|13|13|1|13|cell-height|4ln>|<cwith|13|13|1|13|cell-vmode|exact>|<cwith|15|15|11|13|cell-width|1.5em>|<cwith|15|15|11|13|cell-hmode|exact>|<cwith|15|15|9|9|cell-tborder|0ln>|<cwith|15|15|9|9|cell-bborder|0ln>|<cwith|15|15|9|9|cell-width|1.5em>|<cwith|15|15|9|9|cell-hmode|exact>|<cwith|15|15|1|13|cell-lborder|0ln>|<cwith|15|15|1|13|cell-rborder|0ln>|<cwith|15|15|1|13|cell-height|4ln>|<cwith|15|15|1|13|cell-vmode|exact>|<table|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|Shift
      by>|<cell|<math|\<sigma\><rsub|0>>>|<cell|<math|\<sigma\><rsub|1>>>|<cell|<math|\<sigma\><rsub|2>>>>|<row|<cell|<math|m<rsub|0,0>>>|<cell|<math|m<rsub|0,1>>>|<cell|<math|m<rsub|0,2>>>|<cell|<math|m<rsub|0,3>>>|<cell|<math|m<rsub|0,4>>>|<cell|<math|m<rsub|0,5>>>|<cell|<math|m<rsub|0,6>>>|<cell|<math|m<rsub|0,7>>>|<cell|>|<cell|3>|<cell|1>|<cell|1>|<cell|0>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|m<rsub|1,0>>>|<cell|<math|m<rsub|1,1>>>|<cell|<math|m<rsub|1,2>>>|<cell|<math|m<rsub|1,3>>>|<cell|<math|m<rsub|1,4>>>|<cell|<math|m<rsub|1,5>>>|<cell|<math|m<rsub|1,6>>>|<cell|<math|m<rsub|1,7>>>|<cell|>|<cell|2>|<cell|0>|<cell|1>|<cell|0>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|m<rsub|2,0>>>|<cell|<math|m<rsub|2,1>>>|<cell|<math|m<rsub|2,2>>>|<cell|<math|m<rsub|2,3>>>|<cell|<math|m<rsub|2,4>>>|<cell|<math|m<rsub|2,5>>>|<cell|<math|m<rsub|2,6>>>|<cell|<math|m<rsub|2,7>>>|<cell|>|<cell|5>|<cell|1>|<cell|0>|<cell|1>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|m<rsub|3,0>>>|<cell|<math|m<rsub|3,1>>>|<cell|<math|m<rsub|3,2>>>|<cell|<math|m<rsub|3,3>>>|<cell|<math|m<rsub|3,4>>>|<cell|<math|m<rsub|3,5>>>|<cell|<math|m<rsub|3,6>>>|<cell|<math|m<rsub|3,7>>>|<cell|>|<cell|11<math|>>|<cell|1>|<cell|1>|<cell|1>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|m<rsub|4,0>>>|<cell|<math|m<rsub|4,1>>>|<cell|<math|m<rsub|4,2>>>|<cell|<math|m<rsub|4,3>>>|<cell|<math|m<rsub|4,4>>>|<cell|<math|m<rsub|4,5>>>|<cell|<math|m<rsub|4,6>>>|<cell|<math|m<rsub|4,7>>>|<cell|>|<cell|0>|<cell|0>|<cell|0>|<cell|0>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|m<rsub|5,0>>>|<cell|<math|m<rsub|5,1>>>|<cell|<math|m<rsub|5,2>>>|<cell|<math|m<rsub|5,3>>>|<cell|<math|m<rsub|5,4>>>|<cell|<math|m<rsub|5,5>>>|<cell|<math|m<rsub|5,6>>>|<cell|<math|m<rsub|5,7>>>|<cell|>|<cell|4>|<cell|0>|<cell|0>|<cell|1>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|m<rsub|6,0>>>|<cell|<math|m<rsub|6,1>>>|<cell|<math|m<rsub|6,2>>>|<cell|<math|m<rsub|6,3>>>|<cell|<math|m<rsub|6,4>>>|<cell|<math|m<rsub|6,5>>>|<cell|<math|m<rsub|6,6>>>|<cell|<math|m<rsub|6,7>>>|<cell|>|<cell|4>|<cell|0>|<cell|0>|<cell|1>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|m<rsub|7,0>>>|<cell|<math|m<rsub|7,1>>>|<cell|<math|m<rsub|7,2>>>|<cell|<math|m<rsub|7,3>>>|<cell|<math|m<rsub|7,4>>>|<cell|<math|m<rsub|7,5>>>|<cell|<math|m<rsub|7,6>>>|<cell|<math|m<rsub|7,7>>>|<cell|>|<cell|6>|<cell|0>|<cell|1>|<cell|1>>>>><htab|5mm>
    </shown>|<\hidden>
      <htab|5mm><block*|<tformat|<cwith|2|2|1|-1|cell-width|3em>|<cwith|2|2|1|-1|cell-hmode|exact>|<cwith|1|-1|11|13|cell-width|1.5em>|<cwith|1|-1|11|13|cell-hmode|exact>|<cwith|1|1|1|-1|cell-tborder|0ln>|<cwith|1|1|1|-1|cell-bborder|1ln>|<cwith|2|2|1|-1|cell-tborder|1ln>|<cwith|1|1|1|13|cell-lborder|0ln>|<cwith|1|1|1|13|cell-rborder|0ln>|<cwith|2|2|9|9|cell-tborder|0ln>|<cwith|1|1|9|9|cell-bborder|0ln>|<cwith|16|16|9|9|cell-bborder|0ln>|||<cwith|2|-1|9|9|cell-tborder|0ln>|<cwith|2|-1|9|9|cell-bborder|0ln>|<cwith|1|-1|9|9|cell-width|1.5em>|<cwith|1|-1|9|9|cell-hmode|exact>|<cwith|4|4|1|8|cell-width|3em>|<cwith|4|4|1|8|cell-hmode|exact>|<cwith|6|6|1|8|cell-width|3em>|<cwith|6|6|1|8|cell-hmode|exact>|<cwith|6|6|1|8|cell-tborder|1ln>|<cwith|8|8|1|8|cell-width|3em>|<cwith|8|8|1|8|cell-hmode|exact>|<cwith|8|8|1|8|cell-tborder|1ln>|<cwith|10|10|1|8|cell-width|3em>|<cwith|10|10|1|8|cell-hmode|exact>|<cwith|10|10|1|8|cell-tborder|1ln>|<cwith|12|12|1|8|cell-width|3em>|<cwith|12|12|1|8|cell-hmode|exact>|<cwith|12|12|1|8|cell-tborder|1ln>|<cwith|14|14|1|8|cell-width|3em>|<cwith|14|14|1|8|cell-hmode|exact>|<cwith|14|14|1|8|cell-tborder|1ln>|<cwith|16|16|1|8|cell-width|3em>|<cwith|16|16|1|8|cell-hmode|exact>||||||<cwith|3|3|1|-1|cell-lborder|0ln>|<cwith|3|3|1|-1|cell-rborder|0ln>|<cwith|3|3|1|-1|cell-height|4ln>|<cwith|3|3|1|-1|cell-vmode|exact>|<cwith|5|5|11|13|cell-width|1.5em>|<cwith|5|5|11|13|cell-hmode|exact>|<cwith|5|5|9|9|cell-tborder|0ln>|<cwith|5|5|9|9|cell-bborder|0ln>|<cwith|5|5|9|9|cell-width|1.5em>|<cwith|5|5|9|9|cell-hmode|exact>|<cwith|5|5|1|13|cell-lborder|0ln>|<cwith|5|5|1|13|cell-rborder|0ln>|<cwith|5|5|1|13|cell-height|4ln>|<cwith|5|5|1|13|cell-vmode|exact>|<cwith|7|7|11|13|cell-width|1.5em>|<cwith|7|7|11|13|cell-hmode|exact>|<cwith|7|7|9|9|cell-tborder|0ln>|<cwith|7|7|9|9|cell-bborder|0ln>|<cwith|7|7|9|9|cell-width|1.5em>|<cwith|7|7|9|9|cell-hmode|exact>|<cwith|7|7|1|13|cell-lborder|0ln>|<cwith|7|7|1|13|cell-rborder|0ln>|<cwith|7|7|1|13|cell-height|4ln>|<cwith|7|7|1|13|cell-vmode|exact>|<cwith|9|9|11|13|cell-width|1.5em>|<cwith|9|9|11|13|cell-hmode|exact>|<cwith|9|9|9|9|cell-tborder|0ln>|<cwith|9|9|9|9|cell-bborder|0ln>|<cwith|9|9|9|9|cell-width|1.5em>|<cwith|9|9|9|9|cell-hmode|exact>|<cwith|9|9|1|13|cell-lborder|0ln>|<cwith|9|9|1|13|cell-rborder|0ln>|<cwith|9|9|1|13|cell-height|4ln>|<cwith|9|9|1|13|cell-vmode|exact>|<cwith|11|11|11|13|cell-width|1.5em>|<cwith|11|11|11|13|cell-hmode|exact>|<cwith|11|11|9|9|cell-tborder|0ln>|<cwith|11|11|9|9|cell-bborder|0ln>|<cwith|11|11|9|9|cell-width|1.5em>|<cwith|11|11|9|9|cell-hmode|exact>|<cwith|11|11|1|13|cell-lborder|0ln>|<cwith|11|11|1|13|cell-rborder|0ln>|<cwith|11|11|1|13|cell-height|4ln>|<cwith|11|11|1|13|cell-vmode|exact>|<cwith|13|13|11|13|cell-width|1.5em>|<cwith|13|13|11|13|cell-hmode|exact>|<cwith|13|13|9|9|cell-tborder|0ln>|<cwith|13|13|9|9|cell-bborder|0ln>|<cwith|13|13|9|9|cell-width|1.5em>|<cwith|13|13|9|9|cell-hmode|exact>|<cwith|13|13|1|13|cell-lborder|0ln>|<cwith|13|13|1|13|cell-rborder|0ln>|<cwith|13|13|1|13|cell-height|4ln>|<cwith|13|13|1|13|cell-vmode|exact>|<cwith|15|15|11|13|cell-width|1.5em>|<cwith|15|15|11|13|cell-hmode|exact>|<cwith|15|15|9|9|cell-tborder|0ln>|<cwith|15|15|9|9|cell-bborder|0ln>|<cwith|15|15|9|9|cell-width|1.5em>|<cwith|15|15|9|9|cell-hmode|exact>|<cwith|15|15|1|13|cell-lborder|0ln>|<cwith|15|15|1|13|cell-rborder|0ln>|<cwith|15|15|1|13|cell-height|4ln>|<cwith|15|15|1|13|cell-vmode|exact>|<cwith|2|2|2|8|cell-width|3em>|<cwith|2|2|2|8|cell-hmode|exact>|<cwith|2|2|2|8|cell-tborder|1ln>|<cwith|6|6|2|8|cell-width|3em>|<cwith|6|6|2|8|cell-hmode|exact>|<cwith|6|6|2|8|cell-tborder|1ln>|<cwith|8|8|2|8|cell-width|3em>|<cwith|8|8|2|8|cell-hmode|exact>|<cwith|8|8|2|8|cell-tborder|1ln>|<cwith|2|2|11|11|cell-background|pastel
      red>|<cwith|6|6|11|11|cell-background|pastel
      red>|<cwith|8|8|11|11|cell-background|pastel
      red>|<cwith|4|4|11|11|cell-background|>|<cwith|2|2|1|8|cell-background|pastel
      red>|<cwith|6|6|1|8|cell-background|pastel
      red>|<cwith|8|8|1|8|cell-background|pastel
      red>|<table|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|Shift
      by>|<cell|<math|\<sigma\><rsub|0>>>|<cell|<math|\<sigma\><rsub|1>>>|<cell|<math|\<sigma\><rsub|2>>>>|<row|<cell|0>|<cell|<math|m<rsub|0,0>>>|<cell|<math|m<rsub|0,1>>>|<cell|<math|m<rsub|0,2>>>|<cell|<math|m<rsub|0,3>>>|<cell|<math|m<rsub|0,4>>>|<cell|<math|m<rsub|0,5>>>|<cell|<math|m<rsub|0,6>>>|<cell|>|<cell|3>|<cell|1>|<cell|1>|<cell|0>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|m<rsub|1,0>>>|<cell|<math|m<rsub|1,1>>>|<cell|<math|m<rsub|1,2>>>|<cell|<math|m<rsub|1,3>>>|<cell|<math|m<rsub|1,4>>>|<cell|<math|m<rsub|1,5>>>|<cell|<math|m<rsub|1,6>>>|<cell|<math|m<rsub|1,7>>>|<cell|>|<cell|2>|<cell|0>|<cell|1>|<cell|0>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|0>|<cell|<math|m<rsub|2,0>>>|<cell|<math|m<rsub|2,1>>>|<cell|<math|m<rsub|2,2>>>|<cell|<math|m<rsub|2,3>>>|<cell|<math|m<rsub|2,4>>>|<cell|<math|m<rsub|2,5>>>|<cell|<math|m<rsub|2,6>>>|<cell|>|<cell|5>|<cell|1>|<cell|0>|<cell|1>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|0>|<cell|<math|m<rsub|3,0>>>|<cell|<math|m<rsub|3,1>>>|<cell|<math|m<rsub|3,2>>>|<cell|<math|m<rsub|3,3>>>|<cell|<math|m<rsub|3,4>>>|<cell|<math|m<rsub|3,5>>>|<cell|<math|m<rsub|3,6>>>|<cell|>|<cell|11<math|>>|<cell|1>|<cell|1>|<cell|1>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|m<rsub|4,0>>>|<cell|<math|m<rsub|4,1>>>|<cell|<math|m<rsub|4,2>>>|<cell|<math|m<rsub|4,3>>>|<cell|<math|m<rsub|4,4>>>|<cell|<math|m<rsub|4,5>>>|<cell|<math|m<rsub|4,6>>>|<cell|<math|m<rsub|4,7>>>|<cell|>|<cell|0>|<cell|0>|<cell|0>|<cell|0>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|m<rsub|5,0>>>|<cell|<math|m<rsub|5,1>>>|<cell|<math|m<rsub|5,2>>>|<cell|<math|m<rsub|5,3>>>|<cell|<math|m<rsub|5,4>>>|<cell|<math|m<rsub|5,5>>>|<cell|<math|m<rsub|5,6>>>|<cell|<math|m<rsub|5,7>>>|<cell|>|<cell|4>|<cell|0>|<cell|0>|<cell|1>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|m<rsub|6,0>>>|<cell|<math|m<rsub|6,1>>>|<cell|<math|m<rsub|6,2>>>|<cell|<math|m<rsub|6,3>>>|<cell|<math|m<rsub|6,4>>>|<cell|<math|m<rsub|6,5>>>|<cell|<math|m<rsub|6,6>>>|<cell|<math|m<rsub|6,7>>>|<cell|>|<cell|4>|<cell|0>|<cell|0>|<cell|1>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|m<rsub|7,0>>>|<cell|<math|m<rsub|7,1>>>|<cell|<math|m<rsub|7,2>>>|<cell|<math|m<rsub|7,3>>>|<cell|<math|m<rsub|7,4>>>|<cell|<math|m<rsub|7,5>>>|<cell|<math|m<rsub|7,6>>>|<cell|<math|m<rsub|7,7>>>|<cell|>|<cell|6>|<cell|0>|<cell|1>|<cell|1>>>>><htab|5mm>
    </hidden>|<\hidden>
      <htab|5mm><block*|<tformat|<cwith|2|2|1|-1|cell-width|3em>|<cwith|2|2|1|-1|cell-hmode|exact>|<cwith|1|-1|11|13|cell-width|1.5em>|<cwith|1|-1|11|13|cell-hmode|exact>|<cwith|1|1|1|-1|cell-tborder|0ln>|<cwith|1|1|1|-1|cell-bborder|1ln>|<cwith|2|2|1|-1|cell-tborder|1ln>|<cwith|1|1|1|13|cell-lborder|0ln>|<cwith|1|1|1|13|cell-rborder|0ln>|<cwith|2|2|9|9|cell-tborder|0ln>|<cwith|1|1|9|9|cell-bborder|0ln>|<cwith|16|16|9|9|cell-bborder|0ln>|||<cwith|2|-1|9|9|cell-tborder|0ln>|<cwith|2|-1|9|9|cell-bborder|0ln>|<cwith|1|-1|9|9|cell-width|1.5em>|<cwith|1|-1|9|9|cell-hmode|exact>|<cwith|4|4|1|8|cell-width|3em>|<cwith|4|4|1|8|cell-hmode|exact>|<cwith|6|6|1|8|cell-width|3em>|<cwith|6|6|1|8|cell-hmode|exact>|<cwith|6|6|1|8|cell-tborder|1ln>|<cwith|8|8|1|8|cell-width|3em>|<cwith|8|8|1|8|cell-hmode|exact>|<cwith|8|8|1|8|cell-tborder|1ln>|<cwith|10|10|1|8|cell-width|3em>|<cwith|10|10|1|8|cell-hmode|exact>|<cwith|10|10|1|8|cell-tborder|1ln>|<cwith|12|12|1|8|cell-width|3em>|<cwith|12|12|1|8|cell-hmode|exact>|<cwith|12|12|1|8|cell-tborder|1ln>|<cwith|14|14|1|8|cell-width|3em>|<cwith|14|14|1|8|cell-hmode|exact>|<cwith|14|14|1|8|cell-tborder|1ln>|<cwith|16|16|1|8|cell-width|3em>|<cwith|16|16|1|8|cell-hmode|exact>||||||<cwith|3|3|1|-1|cell-lborder|0ln>|<cwith|3|3|1|-1|cell-rborder|0ln>|<cwith|3|3|1|-1|cell-height|4ln>|<cwith|3|3|1|-1|cell-vmode|exact>|<cwith|5|5|11|13|cell-width|1.5em>|<cwith|5|5|11|13|cell-hmode|exact>|<cwith|5|5|9|9|cell-tborder|0ln>|<cwith|5|5|9|9|cell-bborder|0ln>|<cwith|5|5|9|9|cell-width|1.5em>|<cwith|5|5|9|9|cell-hmode|exact>|<cwith|5|5|1|13|cell-lborder|0ln>|<cwith|5|5|1|13|cell-rborder|0ln>|<cwith|5|5|1|13|cell-height|4ln>|<cwith|5|5|1|13|cell-vmode|exact>|<cwith|7|7|11|13|cell-width|1.5em>|<cwith|7|7|11|13|cell-hmode|exact>|<cwith|7|7|9|9|cell-tborder|0ln>|<cwith|7|7|9|9|cell-bborder|0ln>|<cwith|7|7|9|9|cell-width|1.5em>|<cwith|7|7|9|9|cell-hmode|exact>|<cwith|7|7|1|13|cell-lborder|0ln>|<cwith|7|7|1|13|cell-rborder|0ln>|<cwith|7|7|1|13|cell-height|4ln>|<cwith|7|7|1|13|cell-vmode|exact>|<cwith|9|9|11|13|cell-width|1.5em>|<cwith|9|9|11|13|cell-hmode|exact>|<cwith|9|9|9|9|cell-tborder|0ln>|<cwith|9|9|9|9|cell-bborder|0ln>|<cwith|9|9|9|9|cell-width|1.5em>|<cwith|9|9|9|9|cell-hmode|exact>|<cwith|9|9|1|13|cell-lborder|0ln>|<cwith|9|9|1|13|cell-rborder|0ln>|<cwith|9|9|1|13|cell-height|4ln>|<cwith|9|9|1|13|cell-vmode|exact>|<cwith|11|11|11|13|cell-width|1.5em>|<cwith|11|11|11|13|cell-hmode|exact>|<cwith|11|11|9|9|cell-tborder|0ln>|<cwith|11|11|9|9|cell-bborder|0ln>|<cwith|11|11|9|9|cell-width|1.5em>|<cwith|11|11|9|9|cell-hmode|exact>|<cwith|11|11|1|13|cell-lborder|0ln>|<cwith|11|11|1|13|cell-rborder|0ln>|<cwith|11|11|1|13|cell-height|4ln>|<cwith|11|11|1|13|cell-vmode|exact>|<cwith|13|13|11|13|cell-width|1.5em>|<cwith|13|13|11|13|cell-hmode|exact>|<cwith|13|13|9|9|cell-tborder|0ln>|<cwith|13|13|9|9|cell-bborder|0ln>|<cwith|13|13|9|9|cell-width|1.5em>|<cwith|13|13|9|9|cell-hmode|exact>|<cwith|13|13|1|13|cell-lborder|0ln>|<cwith|13|13|1|13|cell-rborder|0ln>|<cwith|13|13|1|13|cell-height|4ln>|<cwith|13|13|1|13|cell-vmode|exact>|<cwith|15|15|11|13|cell-width|1.5em>|<cwith|15|15|11|13|cell-hmode|exact>|<cwith|15|15|9|9|cell-tborder|0ln>|<cwith|15|15|9|9|cell-bborder|0ln>|<cwith|15|15|9|9|cell-width|1.5em>|<cwith|15|15|9|9|cell-hmode|exact>|<cwith|15|15|1|13|cell-lborder|0ln>|<cwith|15|15|1|13|cell-rborder|0ln>|<cwith|15|15|1|13|cell-height|4ln>|<cwith|15|15|1|13|cell-vmode|exact>|<cwith|2|2|2|8|cell-width|3em>|<cwith|2|2|2|8|cell-hmode|exact>|<cwith|2|2|2|8|cell-tborder|1ln>|<cwith|6|6|2|8|cell-width|3em>|<cwith|6|6|2|8|cell-hmode|exact>|<cwith|6|6|2|8|cell-tborder|1ln>|<cwith|8|8|2|8|cell-width|3em>|<cwith|8|8|2|8|cell-hmode|exact>|<cwith|8|8|2|8|cell-tborder|1ln>|<cwith|2|2|11|11|cell-background|pastel
      red>|<cwith|6|6|11|11|cell-background|pastel
      red>|<cwith|8|8|11|11|cell-background|pastel
      red>|<cwith|4|4|11|11|cell-background|>|<cwith|2|8|1|8|cell-background|>|<cwith|2|2|12|12|cell-background|pastel
      green>|<cwith|4|4|12|12|cell-background|pastel
      green>|<cwith|8|8|12|12|cell-background|pastel
      green>|<cwith|16|16|12|12|cell-background|pastel
      green>|<cwith|2|2|3|8|cell-width|3em>|<cwith|2|2|3|8|cell-hmode|exact>|<cwith|2|2|3|8|cell-tborder|1ln>|<cwith|2|2|4|8|cell-width|3em>|<cwith|2|2|4|8|cell-hmode|exact>|<cwith|2|2|4|8|cell-tborder|1ln>|<cwith|4|4|3|8|cell-width|3em>|<cwith|4|4|3|8|cell-hmode|exact>|<cwith|8|8|3|8|cell-width|3em>|<cwith|8|8|3|8|cell-hmode|exact>|<cwith|8|8|3|8|cell-tborder|1ln>|<cwith|8|8|4|8|cell-width|3em>|<cwith|8|8|4|8|cell-hmode|exact>|<cwith|8|8|4|8|cell-tborder|1ln>|<cwith|16|16|3|8|cell-width|3em>|<cwith|16|16|3|8|cell-hmode|exact>|<cwith|2|2|1|8|cell-background|pastel
      green>|<cwith|4|4|1|8|cell-background|pastel
      green>|<cwith|8|8|1|8|cell-background|pastel
      green>|<cwith|16|16|1|8|cell-background|pastel
      green>|<table|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|Shift
      by>|<cell|<math|\<sigma\><rsub|0>>>|<cell|<math|\<sigma\><rsub|1>>>|<cell|<math|\<sigma\><rsub|2>>>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|<math|m<rsub|0,0>>>|<cell|<math|m<rsub|0,1>>>|<cell|<math|m<rsub|0,2>>>|<cell|<math|m<rsub|0,3>>>|<cell|<math|m<rsub|0,4>>>|<cell|>|<cell|3>|<cell|1>|<cell|1>|<cell|0>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|0>|<cell|0>|<cell|<math|m<rsub|1,0>>>|<cell|<math|m<rsub|1,1>>>|<cell|<math|m<rsub|1,2>>>|<cell|<math|m<rsub|1,3>>>|<cell|<math|m<rsub|1,4>>>|<cell|<math|m<rsub|1,5>>>|<cell|>|<cell|2>|<cell|0>|<cell|1>|<cell|0>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|0>|<cell|<math|m<rsub|2,0>>>|<cell|<math|m<rsub|2,1>>>|<cell|<math|m<rsub|2,2>>>|<cell|<math|m<rsub|2,3>>>|<cell|<math|m<rsub|2,4>>>|<cell|<math|m<rsub|2,5>>>|<cell|<math|m<rsub|2,6>>>|<cell|>|<cell|5>|<cell|1>|<cell|0>|<cell|1>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|<math|m<rsub|3,0>>>|<cell|<math|m<rsub|3,1>>>|<cell|<math|m<rsub|3,2>>>|<cell|<math|m<rsub|3,3>>>|<cell|<math|m<rsub|3,4>>>|<cell|>|<cell|11<math|>>|<cell|1>|<cell|1>|<cell|1>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|m<rsub|4,0>>>|<cell|<math|m<rsub|4,1>>>|<cell|<math|m<rsub|4,2>>>|<cell|<math|m<rsub|4,3>>>|<cell|<math|m<rsub|4,4>>>|<cell|<math|m<rsub|4,5>>>|<cell|<math|m<rsub|4,6>>>|<cell|<math|m<rsub|4,7>>>|<cell|>|<cell|0>|<cell|0>|<cell|0>|<cell|0>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|m<rsub|5,0>>>|<cell|<math|m<rsub|5,1>>>|<cell|<math|m<rsub|5,2>>>|<cell|<math|m<rsub|5,3>>>|<cell|<math|m<rsub|5,4>>>|<cell|<math|m<rsub|5,5>>>|<cell|<math|m<rsub|5,6>>>|<cell|<math|m<rsub|5,7>>>|<cell|>|<cell|4>|<cell|0>|<cell|0>|<cell|1>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|m<rsub|6,0>>>|<cell|<math|m<rsub|6,1>>>|<cell|<math|m<rsub|6,2>>>|<cell|<math|m<rsub|6,3>>>|<cell|<math|m<rsub|6,4>>>|<cell|<math|m<rsub|6,5>>>|<cell|<math|m<rsub|6,6>>>|<cell|<math|m<rsub|6,7>>>|<cell|>|<cell|4>|<cell|0>|<cell|0>|<cell|1>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|0>|<cell|0>|<cell|<math|m<rsub|7,0>>>|<cell|<math|m<rsub|7,1>>>|<cell|<math|m<rsub|7,2>>>|<cell|<math|m<rsub|7,3>>>|<cell|<math|m<rsub|7,4>>>|<cell|<math|m<rsub|7,5>>>|<cell|>|<cell|6>|<cell|0>|<cell|1>|<cell|1>>>>><htab|5mm>
    </hidden>|<\hidden>
      <htab|5mm><block*|<tformat|<cwith|2|2|1|-1|cell-width|3em>|<cwith|2|2|1|-1|cell-hmode|exact>|<cwith|1|-1|11|13|cell-width|1.5em>|<cwith|1|-1|11|13|cell-hmode|exact>|<cwith|1|1|1|-1|cell-tborder|0ln>|<cwith|1|1|1|-1|cell-bborder|1ln>|<cwith|2|2|1|-1|cell-tborder|1ln>|<cwith|1|1|1|13|cell-lborder|0ln>|<cwith|1|1|1|13|cell-rborder|0ln>|<cwith|2|2|9|9|cell-tborder|0ln>|<cwith|1|1|9|9|cell-bborder|0ln>|<cwith|16|16|9|9|cell-bborder|0ln>|||<cwith|2|-1|9|9|cell-tborder|0ln>|<cwith|2|-1|9|9|cell-bborder|0ln>|<cwith|1|-1|9|9|cell-width|1.5em>|<cwith|1|-1|9|9|cell-hmode|exact>|<cwith|4|4|1|8|cell-width|3em>|<cwith|4|4|1|8|cell-hmode|exact>|<cwith|6|6|1|8|cell-width|3em>|<cwith|6|6|1|8|cell-hmode|exact>|<cwith|6|6|1|8|cell-tborder|1ln>|<cwith|8|8|1|8|cell-width|3em>|<cwith|8|8|1|8|cell-hmode|exact>|<cwith|8|8|1|8|cell-tborder|1ln>|<cwith|10|10|1|8|cell-width|3em>|<cwith|10|10|1|8|cell-hmode|exact>|<cwith|10|10|1|8|cell-tborder|1ln>|<cwith|12|12|1|8|cell-width|3em>|<cwith|12|12|1|8|cell-hmode|exact>|<cwith|12|12|1|8|cell-tborder|1ln>|<cwith|14|14|1|8|cell-width|3em>|<cwith|14|14|1|8|cell-hmode|exact>|<cwith|14|14|1|8|cell-tborder|1ln>|<cwith|16|16|1|8|cell-width|3em>|<cwith|16|16|1|8|cell-hmode|exact>||||||<cwith|3|3|1|-1|cell-lborder|0ln>|<cwith|3|3|1|-1|cell-rborder|0ln>|<cwith|3|3|1|-1|cell-height|4ln>|<cwith|3|3|1|-1|cell-vmode|exact>|<cwith|5|5|11|13|cell-width|1.5em>|<cwith|5|5|11|13|cell-hmode|exact>|<cwith|5|5|9|9|cell-tborder|0ln>|<cwith|5|5|9|9|cell-bborder|0ln>|<cwith|5|5|9|9|cell-width|1.5em>|<cwith|5|5|9|9|cell-hmode|exact>|<cwith|5|5|1|13|cell-lborder|0ln>|<cwith|5|5|1|13|cell-rborder|0ln>|<cwith|5|5|1|13|cell-height|4ln>|<cwith|5|5|1|13|cell-vmode|exact>|<cwith|7|7|11|13|cell-width|1.5em>|<cwith|7|7|11|13|cell-hmode|exact>|<cwith|7|7|9|9|cell-tborder|0ln>|<cwith|7|7|9|9|cell-bborder|0ln>|<cwith|7|7|9|9|cell-width|1.5em>|<cwith|7|7|9|9|cell-hmode|exact>|<cwith|7|7|1|13|cell-lborder|0ln>|<cwith|7|7|1|13|cell-rborder|0ln>|<cwith|7|7|1|13|cell-height|4ln>|<cwith|7|7|1|13|cell-vmode|exact>|<cwith|9|9|11|13|cell-width|1.5em>|<cwith|9|9|11|13|cell-hmode|exact>|<cwith|9|9|9|9|cell-tborder|0ln>|<cwith|9|9|9|9|cell-bborder|0ln>|<cwith|9|9|9|9|cell-width|1.5em>|<cwith|9|9|9|9|cell-hmode|exact>|<cwith|9|9|1|13|cell-lborder|0ln>|<cwith|9|9|1|13|cell-rborder|0ln>|<cwith|9|9|1|13|cell-height|4ln>|<cwith|9|9|1|13|cell-vmode|exact>|<cwith|11|11|11|13|cell-width|1.5em>|<cwith|11|11|11|13|cell-hmode|exact>|<cwith|11|11|9|9|cell-tborder|0ln>|<cwith|11|11|9|9|cell-bborder|0ln>|<cwith|11|11|9|9|cell-width|1.5em>|<cwith|11|11|9|9|cell-hmode|exact>|<cwith|11|11|1|13|cell-lborder|0ln>|<cwith|11|11|1|13|cell-rborder|0ln>|<cwith|11|11|1|13|cell-height|4ln>|<cwith|11|11|1|13|cell-vmode|exact>|<cwith|13|13|11|13|cell-width|1.5em>|<cwith|13|13|11|13|cell-hmode|exact>|<cwith|13|13|9|9|cell-tborder|0ln>|<cwith|13|13|9|9|cell-bborder|0ln>|<cwith|13|13|9|9|cell-width|1.5em>|<cwith|13|13|9|9|cell-hmode|exact>|<cwith|13|13|1|13|cell-lborder|0ln>|<cwith|13|13|1|13|cell-rborder|0ln>|<cwith|13|13|1|13|cell-height|4ln>|<cwith|13|13|1|13|cell-vmode|exact>|<cwith|15|15|11|13|cell-width|1.5em>|<cwith|15|15|11|13|cell-hmode|exact>|<cwith|15|15|9|9|cell-tborder|0ln>|<cwith|15|15|9|9|cell-bborder|0ln>|<cwith|15|15|9|9|cell-width|1.5em>|<cwith|15|15|9|9|cell-hmode|exact>|<cwith|15|15|1|13|cell-lborder|0ln>|<cwith|15|15|1|13|cell-rborder|0ln>|<cwith|15|15|1|13|cell-height|4ln>|<cwith|15|15|1|13|cell-vmode|exact>|<cwith|2|2|2|8|cell-width|3em>|<cwith|2|2|2|8|cell-hmode|exact>|<cwith|2|2|2|8|cell-tborder|1ln>|<cwith|6|6|2|8|cell-width|3em>|<cwith|6|6|2|8|cell-hmode|exact>|<cwith|6|6|2|8|cell-tborder|1ln>|<cwith|8|8|2|8|cell-width|3em>|<cwith|8|8|2|8|cell-hmode|exact>|<cwith|8|8|2|8|cell-tborder|1ln>|<cwith|2|2|11|11|cell-background|pastel
      red>|<cwith|6|6|11|11|cell-background|pastel
      red>|<cwith|8|8|11|11|cell-background|pastel
      red>|<cwith|4|4|11|11|cell-background|>|<cwith|2|8|1|8|cell-background|>|<cwith|2|2|12|12|cell-background|pastel
      green>|<cwith|4|4|12|12|cell-background|pastel
      green>|<cwith|8|8|12|12|cell-background|pastel
      green>|<cwith|16|16|12|12|cell-background|pastel
      green>|<cwith|2|2|3|8|cell-width|3em>|<cwith|2|2|3|8|cell-hmode|exact>|<cwith|2|2|3|8|cell-tborder|1ln>|<cwith|2|2|4|8|cell-width|3em>|<cwith|2|2|4|8|cell-hmode|exact>|<cwith|2|2|4|8|cell-tborder|1ln>|<cwith|2|2|3|8|cell-background|>|<cwith|4|4|3|8|cell-width|3em>|<cwith|4|4|3|8|cell-hmode|exact>|<cwith|4|4|3|8|cell-background|>|<cwith|8|8|3|8|cell-width|3em>|<cwith|8|8|3|8|cell-hmode|exact>|<cwith|8|8|3|8|cell-tborder|1ln>|<cwith|8|8|4|8|cell-width|3em>|<cwith|8|8|4|8|cell-hmode|exact>|<cwith|8|8|4|8|cell-tborder|1ln>|<cwith|16|16|3|8|cell-width|3em>|<cwith|16|16|3|8|cell-hmode|exact>|<cwith|6|6|13|13|cell-background|pastel
      blue>|<cwith|8|8|13|13|cell-background|pastel
      blue>|<cwith|12|12|13|13|cell-background|pastel
      blue>|<cwith|14|14|13|13|cell-background|pastel
      blue>|<cwith|16|16|13|13|cell-background|pastel
      blue>|<cwith|6|6|5|8|cell-width|3em>|<cwith|6|6|5|8|cell-hmode|exact>|<cwith|6|6|5|8|cell-tborder|1ln>|<cwith|6|6|6|8|cell-width|3em>|<cwith|6|6|6|8|cell-hmode|exact>|<cwith|6|6|6|8|cell-tborder|1ln>|<cwith|8|8|5|8|cell-width|3em>|<cwith|8|8|5|8|cell-hmode|exact>|<cwith|8|8|5|8|cell-tborder|1ln>|<cwith|8|8|6|8|cell-width|3em>|<cwith|8|8|6|8|cell-hmode|exact>|<cwith|8|8|6|8|cell-tborder|1ln>|<cwith|8|8|7|8|cell-width|3em>|<cwith|8|8|7|8|cell-hmode|exact>|<cwith|8|8|7|8|cell-tborder|1ln>|<cwith|8|8|8|8|cell-width|3em>|<cwith|8|8|8|8|cell-hmode|exact>|<cwith|8|8|8|8|cell-tborder|1ln>|<cwith|12|12|5|8|cell-width|3em>|<cwith|12|12|5|8|cell-hmode|exact>|<cwith|12|12|5|8|cell-tborder|1ln>|<cwith|14|14|5|8|cell-width|3em>|<cwith|14|14|5|8|cell-hmode|exact>|<cwith|14|14|5|8|cell-tborder|1ln>|<cwith|16|16|5|8|cell-width|3em>|<cwith|16|16|5|8|cell-hmode|exact>|<cwith|16|16|7|8|cell-width|3em>|<cwith|16|16|7|8|cell-hmode|exact>|<cwith|6|6|1|8|cell-background|pastel
      blue>|<cwith|8|8|1|8|cell-background|pastel
      blue>|<cwith|12|12|1|8|cell-background|pastel
      blue>|<cwith|14|14|1|8|cell-background|pastel
      blue>|<cwith|16|16|1|8|cell-background|pastel
      blue>|<table|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|Shift
      by>|<cell|<math|\<sigma\><rsub|0>>>|<cell|<math|\<sigma\><rsub|1>>>|<cell|<math|\<sigma\><rsub|2>>>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|<math|m<rsub|0,0>>>|<cell|<math|m<rsub|0,1>>>|<cell|<math|m<rsub|0,2>>>|<cell|<math|m<rsub|0,3>>>|<cell|<math|m<rsub|0,4>>>|<cell|>|<cell|3>|<cell|1>|<cell|1>|<cell|0>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|0>|<cell|0>|<cell|<math|m<rsub|1,0>>>|<cell|<math|m<rsub|1,1>>>|<cell|<math|m<rsub|1,2>>>|<cell|<math|m<rsub|1,3>>>|<cell|<math|m<rsub|1,4>>>|<cell|<math|m<rsub|1,5>>>|<cell|>|<cell|2>|<cell|0>|<cell|1>|<cell|0>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|<math|m<rsub|2,0>>>|<cell|<math|m<rsub|2,1>>>|<cell|<math|m<rsub|2,2>>>|<cell|>|<cell|5>|<cell|1>|<cell|0>|<cell|1>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|<math|m<rsub|3,0>>>|<cell|>|<cell|11<math|>>|<cell|1>|<cell|1>|<cell|1>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|m<rsub|4,0>>>|<cell|<math|m<rsub|4,1>>>|<cell|<math|m<rsub|4,2>>>|<cell|<math|m<rsub|4,3>>>|<cell|<math|m<rsub|4,4>>>|<cell|<math|m<rsub|4,5>>>|<cell|<math|m<rsub|4,6>>>|<cell|<math|m<rsub|4,7>>>|<cell|>|<cell|0>|<cell|0>|<cell|0>|<cell|0>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|<math|m<rsub|5,0>>>|<cell|<math|m<rsub|5,1>>>|<cell|<math|m<rsub|5,2>>>|<cell|<math|m<rsub|5,3>>>|<cell|>|<cell|4>|<cell|0>|<cell|0>|<cell|1>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|<math|m<rsub|6,0>>>|<cell|<math|m<rsub|6,1>>>|<cell|<math|m<rsub|6,2>>>|<cell|<math|m<rsub|6,3>>>|<cell|>|<cell|4>|<cell|0>|<cell|0>|<cell|1>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|<math|m<rsub|7,0>>>|<cell|<math|m<rsub|7,1>>>|<cell|>|<cell|6>|<cell|0>|<cell|1>|<cell|1>>>>><htab|5mm>
    </hidden>|<\hidden>
      <htab|5mm><block*|<tformat|<cwith|2|2|1|-1|cell-width|3em>|<cwith|2|2|1|-1|cell-hmode|exact>|<cwith|1|-1|11|13|cell-width|1.5em>|<cwith|1|-1|11|13|cell-hmode|exact>|<cwith|1|1|1|-1|cell-tborder|0ln>|<cwith|1|1|1|-1|cell-bborder|1ln>|<cwith|2|2|1|-1|cell-tborder|1ln>|<cwith|1|1|1|13|cell-lborder|0ln>|<cwith|1|1|1|13|cell-rborder|0ln>|<cwith|2|2|9|9|cell-tborder|0ln>|<cwith|1|1|9|9|cell-bborder|0ln>|<cwith|16|16|9|9|cell-bborder|0ln>|||<cwith|2|-1|9|9|cell-tborder|0ln>|<cwith|2|-1|9|9|cell-bborder|0ln>|<cwith|1|-1|9|9|cell-width|1.5em>|<cwith|1|-1|9|9|cell-hmode|exact>|<cwith|4|4|1|8|cell-width|3em>|<cwith|4|4|1|8|cell-hmode|exact>|<cwith|6|6|1|8|cell-width|3em>|<cwith|6|6|1|8|cell-hmode|exact>|<cwith|6|6|1|8|cell-tborder|1ln>|<cwith|8|8|1|8|cell-width|3em>|<cwith|8|8|1|8|cell-hmode|exact>|<cwith|8|8|1|8|cell-tborder|1ln>|<cwith|10|10|1|8|cell-width|3em>|<cwith|10|10|1|8|cell-hmode|exact>|<cwith|10|10|1|8|cell-tborder|1ln>|<cwith|12|12|1|8|cell-width|3em>|<cwith|12|12|1|8|cell-hmode|exact>|<cwith|12|12|1|8|cell-tborder|1ln>|<cwith|14|14|1|8|cell-width|3em>|<cwith|14|14|1|8|cell-hmode|exact>|<cwith|14|14|1|8|cell-tborder|1ln>|<cwith|16|16|1|8|cell-width|3em>|<cwith|16|16|1|8|cell-hmode|exact>||||||<cwith|3|3|1|-1|cell-lborder|0ln>|<cwith|3|3|1|-1|cell-rborder|0ln>|<cwith|3|3|1|-1|cell-height|4ln>|<cwith|3|3|1|-1|cell-vmode|exact>|<cwith|5|5|11|13|cell-width|1.5em>|<cwith|5|5|11|13|cell-hmode|exact>|<cwith|5|5|9|9|cell-tborder|0ln>|<cwith|5|5|9|9|cell-bborder|0ln>|<cwith|5|5|9|9|cell-width|1.5em>|<cwith|5|5|9|9|cell-hmode|exact>|<cwith|5|5|1|13|cell-lborder|0ln>|<cwith|5|5|1|13|cell-rborder|0ln>|<cwith|5|5|1|13|cell-height|4ln>|<cwith|5|5|1|13|cell-vmode|exact>|<cwith|7|7|11|13|cell-width|1.5em>|<cwith|7|7|11|13|cell-hmode|exact>|<cwith|7|7|9|9|cell-tborder|0ln>|<cwith|7|7|9|9|cell-bborder|0ln>|<cwith|7|7|9|9|cell-width|1.5em>|<cwith|7|7|9|9|cell-hmode|exact>|<cwith|7|7|1|13|cell-lborder|0ln>|<cwith|7|7|1|13|cell-rborder|0ln>|<cwith|7|7|1|13|cell-height|4ln>|<cwith|7|7|1|13|cell-vmode|exact>|<cwith|9|9|11|13|cell-width|1.5em>|<cwith|9|9|11|13|cell-hmode|exact>|<cwith|9|9|9|9|cell-tborder|0ln>|<cwith|9|9|9|9|cell-bborder|0ln>|<cwith|9|9|9|9|cell-width|1.5em>|<cwith|9|9|9|9|cell-hmode|exact>|<cwith|9|9|1|13|cell-lborder|0ln>|<cwith|9|9|1|13|cell-rborder|0ln>|<cwith|9|9|1|13|cell-height|4ln>|<cwith|9|9|1|13|cell-vmode|exact>|<cwith|11|11|11|13|cell-width|1.5em>|<cwith|11|11|11|13|cell-hmode|exact>|<cwith|11|11|9|9|cell-tborder|0ln>|<cwith|11|11|9|9|cell-bborder|0ln>|<cwith|11|11|9|9|cell-width|1.5em>|<cwith|11|11|9|9|cell-hmode|exact>|<cwith|11|11|1|13|cell-lborder|0ln>|<cwith|11|11|1|13|cell-rborder|0ln>|<cwith|11|11|1|13|cell-height|4ln>|<cwith|11|11|1|13|cell-vmode|exact>|<cwith|13|13|11|13|cell-width|1.5em>|<cwith|13|13|11|13|cell-hmode|exact>|<cwith|13|13|9|9|cell-tborder|0ln>|<cwith|13|13|9|9|cell-bborder|0ln>|<cwith|13|13|9|9|cell-width|1.5em>|<cwith|13|13|9|9|cell-hmode|exact>|<cwith|13|13|1|13|cell-lborder|0ln>|<cwith|13|13|1|13|cell-rborder|0ln>|<cwith|13|13|1|13|cell-height|4ln>|<cwith|13|13|1|13|cell-vmode|exact>|<cwith|15|15|11|13|cell-width|1.5em>|<cwith|15|15|11|13|cell-hmode|exact>|<cwith|15|15|9|9|cell-tborder|0ln>|<cwith|15|15|9|9|cell-bborder|0ln>|<cwith|15|15|9|9|cell-width|1.5em>|<cwith|15|15|9|9|cell-hmode|exact>|<cwith|15|15|1|13|cell-lborder|0ln>|<cwith|15|15|1|13|cell-rborder|0ln>|<cwith|15|15|1|13|cell-height|4ln>|<cwith|15|15|1|13|cell-vmode|exact>|<cwith|2|2|2|8|cell-width|3em>|<cwith|2|2|2|8|cell-hmode|exact>|<cwith|2|2|2|8|cell-tborder|1ln>|<cwith|6|6|2|8|cell-width|3em>|<cwith|6|6|2|8|cell-hmode|exact>|<cwith|6|6|2|8|cell-tborder|1ln>|<cwith|8|8|2|8|cell-width|3em>|<cwith|8|8|2|8|cell-hmode|exact>|<cwith|8|8|2|8|cell-tborder|1ln>|<cwith|2|2|11|11|cell-background|pastel
      red>|<cwith|6|6|11|11|cell-background|pastel
      red>|<cwith|8|8|11|11|cell-background|pastel
      red>|<cwith|4|4|11|11|cell-background|>|<cwith|2|8|1|8|cell-background|>|<cwith|2|2|12|12|cell-background|pastel
      green>|<cwith|4|4|12|12|cell-background|pastel
      green>|<cwith|8|8|12|12|cell-background|pastel
      green>|<cwith|16|16|12|12|cell-background|pastel
      green>|<cwith|2|2|3|8|cell-width|3em>|<cwith|2|2|3|8|cell-hmode|exact>|<cwith|2|2|3|8|cell-tborder|1ln>|<cwith|2|2|4|8|cell-width|3em>|<cwith|2|2|4|8|cell-hmode|exact>|<cwith|2|2|4|8|cell-tborder|1ln>|<cwith|2|2|3|8|cell-background|>|<cwith|4|4|3|8|cell-width|3em>|<cwith|4|4|3|8|cell-hmode|exact>|<cwith|4|4|3|8|cell-background|>|<cwith|8|8|3|8|cell-width|3em>|<cwith|8|8|3|8|cell-hmode|exact>|<cwith|8|8|3|8|cell-tborder|1ln>|<cwith|8|8|4|8|cell-width|3em>|<cwith|8|8|4|8|cell-hmode|exact>|<cwith|8|8|4|8|cell-tborder|1ln>|<cwith|8|8|3|8|cell-background|>|<cwith|16|16|3|8|cell-width|3em>|<cwith|16|16|3|8|cell-hmode|exact>|<cwith|6|6|13|13|cell-background|pastel
      blue>|<cwith|8|8|13|13|cell-background|pastel
      blue>|<cwith|12|12|13|13|cell-background|pastel
      blue>|<cwith|14|14|13|13|cell-background|pastel
      blue>|<cwith|16|16|13|13|cell-background|pastel
      blue>|<cwith|6|6|5|8|cell-width|3em>|<cwith|6|6|5|8|cell-hmode|exact>|<cwith|6|6|5|8|cell-tborder|1ln>|<cwith|6|6|6|8|cell-width|3em>|<cwith|6|6|6|8|cell-hmode|exact>|<cwith|6|6|6|8|cell-tborder|1ln>|<cwith|6|6|5|8|cell-background|>|<cwith|8|8|5|8|cell-width|3em>|<cwith|8|8|5|8|cell-hmode|exact>|<cwith|8|8|5|8|cell-tborder|1ln>|<cwith|8|8|6|8|cell-width|3em>|<cwith|8|8|6|8|cell-hmode|exact>|<cwith|8|8|6|8|cell-tborder|1ln>|<cwith|8|8|5|8|cell-background|>|<cwith|8|8|7|8|cell-width|3em>|<cwith|8|8|7|8|cell-hmode|exact>|<cwith|8|8|7|8|cell-tborder|1ln>|<cwith|8|8|8|8|cell-width|3em>|<cwith|8|8|8|8|cell-hmode|exact>|<cwith|8|8|8|8|cell-tborder|1ln>|<cwith|8|8|7|8|cell-background|>|<cwith|12|12|5|8|cell-width|3em>|<cwith|12|12|5|8|cell-hmode|exact>|<cwith|12|12|5|8|cell-tborder|1ln>|<cwith|14|14|5|8|cell-width|3em>|<cwith|14|14|5|8|cell-hmode|exact>|<cwith|14|14|5|8|cell-tborder|1ln>|<cwith|16|16|5|8|cell-width|3em>|<cwith|16|16|5|8|cell-hmode|exact>|<cwith|16|16|7|8|cell-width|3em>|<cwith|16|16|7|8|cell-hmode|exact>|<table|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|Shift
      by>|<cell|<math|\<sigma\><rsub|0>>>|<cell|<math|\<sigma\><rsub|1>>>|<cell|<math|\<sigma\><rsub|2>>>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|<math|m<rsub|0,0>>>|<cell|<math|m<rsub|0,1>>>|<cell|<math|m<rsub|0,2>>>|<cell|<math|m<rsub|0,3>>>|<cell|<math|m<rsub|0,4>>>|<cell|>|<cell|3>|<cell|1>|<cell|1>|<cell|0>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|0>|<cell|0>|<cell|<math|m<rsub|1,0>>>|<cell|<math|m<rsub|1,1>>>|<cell|<math|m<rsub|1,2>>>|<cell|<math|m<rsub|1,3>>>|<cell|<math|m<rsub|1,4>>>|<cell|<math|m<rsub|1,5>>>|<cell|>|<cell|2>|<cell|0>|<cell|1>|<cell|0>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|<math|m<rsub|2,0>>>|<cell|<math|m<rsub|2,1>>>|<cell|<math|m<rsub|2,2>>>|<cell|>|<cell|5>|<cell|1>|<cell|0>|<cell|1>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|<math|m<rsub|3,0>>>|<cell|>|<cell|11<math|>>|<cell|1>|<cell|1>|<cell|1>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|m<rsub|4,0>>>|<cell|<math|m<rsub|4,1>>>|<cell|<math|m<rsub|4,2>>>|<cell|<math|m<rsub|4,3>>>|<cell|<math|m<rsub|4,4>>>|<cell|<math|m<rsub|4,5>>>|<cell|<math|m<rsub|4,6>>>|<cell|<math|m<rsub|4,7>>>|<cell|>|<cell|0>|<cell|0>|<cell|0>|<cell|0>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|<math|m<rsub|5,0>>>|<cell|<math|m<rsub|5,1>>>|<cell|<math|m<rsub|5,2>>>|<cell|<math|m<rsub|5,3>>>|<cell|>|<cell|4>|<cell|0>|<cell|0>|<cell|1>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|<math|m<rsub|6,0>>>|<cell|<math|m<rsub|6,1>>>|<cell|<math|m<rsub|6,2>>>|<cell|<math|m<rsub|6,3>>>|<cell|>|<cell|4>|<cell|0>|<cell|0>|<cell|1>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|<math|m<rsub|7,0>>>|<cell|<math|m<rsub|7,1>>>|<cell|>|<cell|6>|<cell|0>|<cell|1>|<cell|1>>>>><htab|5mm>
    </hidden>>

    \;

    Operation count: <math|k*log<rsub|2> k>
  </hidden>|<\hidden>
    <tit|short SIMD shifts>

    \;

    <unroll|<\shown>
      Similar to carry-normalization

      Operation count: <math|4*k-1>

      \;

      \;
    </shown>|<\hidden*>
      <strong|Note>

      One addition <math|r=x+y> requires

      <\itemize>
        <item>One general right shift for <math|x> (put under common
        exponent)

        <item>One general right shift for <math|y> (put under common
        exponent)

        <item>One fixed-point addition

        <item>One general left shift for <math|r> (dot normalization)
      </itemize>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Operation counts>

    \;

    <htab|5mm><strong|Base <math|2>><htab|5mm>

    <htab|5mm><block|<tformat|<cwith|1|-1|3|-1|cell-halign|r>|<cwith|2|2|3|13|cell-halign|r>|<cwith|1|1|1|1|cell-tborder|0ln>|<cwith|1|1|1|1|cell-bborder|1ln>|<cwith|2|2|1|1|cell-tborder|1ln>|<cwith|1|1|1|1|cell-lborder|0ln>|<cwith|1|1|1|1|cell-rborder|1ln>|<cwith|1|1|2|2|cell-lborder|1ln>|<cwith|2|2|1|1|cell-valign|c>|<cwith|4|4|1|1|cell-valign|c>|<cwith|2|2|1|1|cell-row-span|2>|<cwith|2|2|1|1|cell-col-span|1>|<cwith|4|4|1|1|cell-row-span|2>|<cwith|4|4|1|1|cell-col-span|1>|<cwith|4|4|3|13|cell-halign|r>|<table|<row|<cell|>|<cell|<math|k>>|<cell|2>|<cell|3>|<cell|4>|<cell|5>|<cell|6>|<cell|7>|<cell|8>|<cell|9>|<cell|10>|<cell|11>|<cell|12>>|<row|<cell|<math|\<pm\>>>|<cell|Individual
    exponents>|<cell|51>|<cell|84>|<cell|108>|<cell|150>|<cell|177>|<cell|204>|<cell|231>|<cell|288>|<cell|318>|<cell|348>|<cell|378>>|<row|<cell|>|<cell|Shared
    exponents>|<cell|55>|<cell|79>|<cell|103>|<cell|127>|<cell|151>|<cell|175>|<cell|199>|<cell|223>|<cell|247>|<cell|271>|<cell|295>>|<row|<cell|<math|\<times\>>>|<cell|Individual
    exponents>|<cell|31>|<cell|35>|<cell|54>|<cell|78>|<cell|107>|<cell|141>|<cell|180>|<cell|224>|<cell|273>|<cell|327>|<cell|386>>|<row|<cell|>|<cell|Shared
    exponents>|<cell|32>|<cell|36>|<cell|55>|<cell|79>|<cell|108>|<cell|142>|<cell|181>|<cell|225>|<cell|274>|<cell|328>|<cell|387>>|<row|<cell|<math|\<times\>>>|<cell|FP
    expansions>|<cell|138>|<cell|193>|<cell|261>|<cell|342>|<cell|436>|<cell|543>|<cell|663>|<cell|796>|<cell|942>|<cell|1101>|<cell|1273>>>>><htab|5mm>

    \;

    \;

    <htab|5mm><strong|Base <math|2<rsup|p>>><htab|5mm>

    <htab|5mm><block|<tformat|<cwith|1|-1|3|-1|cell-halign|r>|<cwith|1|1|1|1|cell-tborder|0ln>|<cwith|1|1|1|1|cell-bborder|1ln>|<cwith|2|2|1|1|cell-tborder|1ln>|<cwith|1|1|1|1|cell-lborder|0ln>|<cwith|1|1|1|1|cell-rborder|1ln>|<cwith|1|1|2|2|cell-lborder|1ln>|<cwith|2|2|1|1|cell-valign|c>|<cwith|4|4|1|1|cell-valign|c>|<cwith|2|2|1|1|cell-row-span|2>|<cwith|2|2|1|1|cell-col-span|1>|<cwith|4|4|1|1|cell-row-span|2>|<cwith|4|4|1|1|cell-col-span|1>|<cwith|5|5|3|13|cell-halign|r>|<cwith|6|6|3|13|cell-halign|r>|<cwith|5|5|3|13|cell-halign|r>|<table|<row|<cell|>|<cell|<math|k-1>>|<cell|2>|<cell|3>|<cell|4>|<cell|5>|<cell|6>|<cell|7>|<cell|8>|<cell|9>|<cell|10>|<cell|11>|<cell|12>>|<row|<cell|<math|\<pm\>>>|<cell|Individual
    exponents>|<cell|31>|<cell|49>|<cell|67>|<cell|92>|<cell|107>|<cell|122>|<cell|147>|<cell|183>|<cell|201>|<cell|219>|<cell|237>>|<row|<cell|>|<cell|Shared
    exponents>|<cell|31>|<cell|43>|<cell|55>|<cell|67>|<cell|79>|<cell|91>|<cell|103>|<cell|115>|<cell|127>|<cell|139>|<cell|151>>|<row|<cell|<math|\<times\>>>|<cell|Individual
    exponents>|<cell|40>|<cell|61>|<cell|87>|<cell|118>|<cell|154>|<cell|195>|<cell|241>|<cell|292>|<cell|348>|<cell|409>|<cell|475>>|<row|<cell|>|<cell|Shared
    exponents>|<cell|41>|<cell|62>|<cell|88>|<cell|119>|<cell|155>|<cell|196>|<cell|242>|<cell|293>|<cell|349>|<cell|410>|<cell|476>>|<row|<cell|<math|\<times\>>>|<cell|FP
    expansions>|<cell|138>|<cell|193>|<cell|261>|<cell|342>|<cell|436>|<cell|543>|<cell|663>|<cell|796>|<cell|942>|<cell|1101>|<cell|1273>>>>><htab|5mm>
  </hidden>|<\hidden>
    <tit|Conclusion and perspectives>

    <unroll|<\shown>
      <strong|Conclusion>

      <\itemize>
        <unroll|<\shown>
          <item>ARITH 2015: our multiple precision arithmetic is very
          efficient for fixed-point arithmetic

          We were able to achieve <math|\<alpha\>\<leqslant\>2> for practical
          FFT computations

          <htab|5mm><em|<with|color|dark magenta|This was really our best
          case situation>>
        </shown>|<\hidden*>
          <item>ARITH 2017: we expect our approach to outperform floating
          point expansions for <math|k\<geqslant\>5>

          This holds for any of the known approaches: Priest, Bailey,
          Muller\UPopescu\UTang, ...

          <htab|5mm><em|<with|color|dark magenta|Although this is really our
          worst case situation>>
        </hidden*>>
      </itemize>
    </shown>|<\hidden*>
      \;

      <strong|Perspectives>

      <\itemize>
        <item>To make better use of our arithmetic, one should implement
        dedicated functions for

        <\itemize>
          <item>Sums <math|x<rsub|1>+\<cdots\>+x<rsub|t>> of several numbers

          <item>Important specific operations: FFT, matrix multiplication,
          etc.

          <item>Etc.
        </itemize>

        <item>Can compilers use such optimized routines automatically when
        possible<space|0.2spc>?
      </itemize>
    </hidden*>>
  </hidden>>
</body>

<\initial>
  <\collection>
    <associate|info-flag|minimal>
  </collection>
</initial>